diff --git a/logview/loglist.c b/logview/loglist.c
index 572df35..6e8049f 100644
--- a/logview/loglist.c
+++ b/logview/loglist.c
@@ -23,14 +23,16 @@
 #include "loglist.h"
 #include "logrtns.h"
 #include <libgnomevfs/gnome-vfs.h>
+#include <logview-debug.h>
 
-struct LogListPriv {
+#define BOLD_LOG_TIME	5000
+
+struct LogListPrv {
 	GtkTreeStore *model;
+	gpointer window;
+	guint unbold_event;
 };
 
-static GObjectClass *parent_class;
-GType loglist_get_type (void);
-
 enum {
 	LOG_NAME = 0,
 	LOG_POINTER,
@@ -38,6 +40,18 @@ enum {
 	LOG_WEIGHT_SET
 };
 
+enum {
+	PROP_0 = 0,
+	PROP_WINDOW
+};
+
+static void loglist_set_property (GObject      *object,
+				  guint         property_id,
+				  const GValue *value,
+				  GParamSpec   *pspec);
+
+G_DEFINE_TYPE (LogList, loglist, GTK_TYPE_TREE_VIEW)
+
 static GtkTreePath *
 loglist_find_directory (LogList *list, gchar *dir)
 {
@@ -48,14 +62,17 @@ loglist_find_directory (LogList *list, gchar *dir)
 	
 	g_assert (LOG_IS_LIST (list));
 
-	model = GTK_TREE_MODEL (list->priv->model);
+	model = GTK_TREE_MODEL (list->prv->model);
 	if (!gtk_tree_model_get_iter_first (model, &iter))
 		return NULL;
 	
 	do {
 		gtk_tree_model_get (model, &iter, LOG_NAME, &iterdir, -1);
 		if (iterdir) {
-			if (g_ascii_strncasecmp (iterdir, dir, -1) == 0) {
+			gint val;
+			val = g_ascii_strncasecmp (iterdir, dir, -1);
+			g_free (iterdir);
+			if (val == 0) {
 				path = gtk_tree_model_get_path (model, &iter);
 				break;
 			}
@@ -76,9 +93,10 @@ loglist_find_log (LogList *list, Log *log)
 	Log *iterlog;
 	
 	g_assert (LOG_IS_LIST (list));
-	g_assert (log != NULL);       	
+	g_assert (log != NULL);
+	LV_MARK;
 
-	model = GTK_TREE_MODEL (list->priv->model);
+	model = GTK_TREE_MODEL (list->prv->model);
 	if (!gtk_tree_model_get_iter_first (model, &iter))
 		return NULL;
 	
@@ -101,29 +119,34 @@ loglist_get_log_iter (LogList *list, Log *log, GtkTreeIter *logiter)
 {
     GtkTreeModel *model;
     GtkTreePath *path = NULL;
+    LV_MARK;
 
     path = loglist_find_log (list, log);
     if (path) {
-	    model = GTK_TREE_MODEL (list->priv->model);
+	    model = GTK_TREE_MODEL (list->prv->model);
 	    gtk_tree_model_get_iter (model, logiter, path);
 	    gtk_tree_path_free (path);
     }
 }
 
-void
-loglist_unbold_log (LogList *list, Log *log)
+static gboolean
+loglist_unbold (LogList *self)
 {
-    GtkTreeModel *model;
-    GtkTreeIter iter;
+	LogviewWindow *logview = LOGVIEW_WINDOW(self->prv->window);
+	GtkTreeModel *model;
+	GtkTreeIter iter;
+	LV_MARK;
 
-    g_return_if_fail (LOG_IS_LIST (list));
-    g_return_if_fail (log != NULL);
+	model = GTK_TREE_MODEL (self->prv->model);
 
-    model = GTK_TREE_MODEL (list->priv->model);
+	loglist_get_log_iter (self, logview_get_active_log (logview),
+			      &iter);
+	gtk_tree_store_set (GTK_TREE_STORE (model), &iter,
+			    LOG_WEIGHT_SET, FALSE, -1);
 
-    loglist_get_log_iter (list, log, &iter);
-    gtk_tree_store_set (GTK_TREE_STORE (model), &iter,
-			LOG_WEIGHT_SET, FALSE, -1);
+	self->prv->unbold_event = 0;
+	g_object_unref (self);
+	return FALSE;
 }
 
 void
@@ -131,11 +154,13 @@ loglist_bold_log (LogList *list, Log *log)
 {
     GtkTreeModel *model;
     GtkTreeIter iter;
+    LogviewWindow *logview = LOGVIEW_WINDOW(list->prv->window);
+    LV_MARK;
     
     g_return_if_fail (LOG_IS_LIST (list));
     g_return_if_fail (log != NULL);
 
-    model = GTK_TREE_MODEL (list->priv->model);
+    model = GTK_TREE_MODEL (list->prv->model);
 
     loglist_get_log_iter (list, log, &iter);
     gtk_tree_store_set (GTK_TREE_STORE (model), &iter, 
@@ -143,8 +168,10 @@ loglist_bold_log (LogList *list, Log *log)
 			LOG_WEIGHT_SET, TRUE, -1);
 
     /* if the log is currently shown, put up a timer to unbold it */
-    if (logview_get_active_log (log->window) == log)
-        g_timeout_add (5000, log_unbold, log);
+    if (logview_get_active_log (logview) == log)
+	    g_timeout_add (BOLD_LOG_TIME,
+			   (GSourceFunc) loglist_unbold,
+			   g_object_ref (list));
 }
 
 void
@@ -169,33 +196,36 @@ void
 loglist_remove_log (LogList *list, Log *log)
 {
 	GtkTreeIter iter, parent;
+	gchar *name;
 
-    g_return_if_fail (LOG_IS_LIST (list));
-    g_return_if_fail (log != NULL);
+	g_return_if_fail (LOG_IS_LIST (list));
+	g_return_if_fail (log != NULL);
 
-    loglist_get_log_iter (list, log, &iter);
-    gtk_tree_model_iter_parent (GTK_TREE_MODEL (list->priv->model), &parent, &iter);
+	g_object_get (G_OBJECT (log), "path", &name, NULL);
+	loglist_get_log_iter (list, log, &iter);
+	gtk_tree_model_iter_parent (GTK_TREE_MODEL (list->prv->model), &parent, &iter);
 
-    if (gtk_tree_store_remove (list->priv->model, &iter)) {
-        GtkTreeSelection *selection;
-	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
-	gtk_tree_selection_select_iter (selection, &iter);
-    } else {
-	    if (!gtk_tree_model_iter_has_child (GTK_TREE_MODEL (list->priv->model), &parent)) {
-		    if (gtk_tree_store_remove (list->priv->model, &parent)) {
-			    GtkTreeSelection *selection;
-			    selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
-			    gtk_tree_selection_select_iter (selection, &parent);
-		    }
-	    }
-    }
+	if (gtk_tree_store_remove (list->prv->model, &iter)) {
+		GtkTreeSelection *selection;
+		selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
+		gtk_tree_selection_select_iter (selection, &iter);
+	} else {
+		if (!gtk_tree_model_iter_has_child (GTK_TREE_MODEL (list->prv->model), &parent)) {
+			if (gtk_tree_store_remove (list->prv->model, &parent)) {
+				GtkTreeSelection *selection;
+				selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
+				gtk_tree_selection_select_iter (selection, &parent);
+			}
+		}
+	}
+	g_free (name);
 }
 
 void
 loglist_add_directory (LogList *list, gchar *dirname, GtkTreeIter *iter)
 {
-	gtk_tree_store_append (list->priv->model, iter, NULL);
-	gtk_tree_store_set (list->priv->model, iter,
+	gtk_tree_store_append (list->prv->model, iter, NULL);
+	gtk_tree_store_set (list->prv->model, iter,
 			    LOG_NAME, dirname, LOG_POINTER, NULL, -1);
 }
 
@@ -209,17 +239,16 @@ loglist_add_log (LogList *list, Log *log)
 	g_return_if_fail (LOG_IS_LIST (list));
 	g_return_if_fail (log != NULL);
 
-	dirname = log_extract_dirname (log);
+	log_extract_filepath (log, &dirname, &filename);
 	path = loglist_find_directory (list, dirname);
 	if (path) {
-		gtk_tree_model_get_iter (GTK_TREE_MODEL (list->priv->model), &iter, path);
+		gtk_tree_model_get_iter (GTK_TREE_MODEL (list->prv->model), &iter, path);
 		gtk_tree_path_free (path);
 	} else
 		loglist_add_directory (list, dirname, &iter);
 
-	filename = log_extract_filename (log);
-	gtk_tree_store_append (list->priv->model, &child_iter, &iter);
-	gtk_tree_store_set (list->priv->model, &child_iter, 
+	gtk_tree_store_append (list->prv->model, &child_iter, &iter);
+	gtk_tree_store_set (list->prv->model, &child_iter, 
                         LOG_NAME, filename, LOG_POINTER, log, -1);
 
 	if (GTK_WIDGET_VISIBLE (GTK_WIDGET (list)))
@@ -230,121 +259,129 @@ loglist_add_log (LogList *list, Log *log)
 }
 
 static void
-loglist_selection_changed (GtkTreeSelection *selection, LogviewWindow *logview)
+loglist_selection_changed (GtkTreeSelection *selection, LogList *self)
 {
-  GtkTreeModel *model;
-  GtkTreeIter iter;
-  gboolean bold;
-  gchar *name;
-  Log *log;
-
-  g_assert (LOGVIEW_IS_WINDOW (logview));
-  g_assert (GTK_IS_TREE_SELECTION (selection));  
-
-  if (!gtk_tree_selection_get_selected (selection, &model, &iter)) {
-      logview_select_log (logview, NULL);
-      return;
-  }
-
-  gtk_tree_model_get (model, &iter, 
-		      LOG_NAME, &name, 
-		      LOG_POINTER, &log, 
-		      LOG_WEIGHT_SET, &bold, -1);
-  logview_select_log (logview, log);
-  if (bold)
-      g_timeout_add (5000, log_unbold, log);
-}
+	LogviewWindow *logview = LOGVIEW_WINDOW(self->prv->window);
+	GtkTreeModel *model;
+	GtkTreeIter iter;
+	gboolean bold;
+	Log *log;
 
-void
-loglist_connect (LogList *list, LogviewWindow *logview)
-{
-    GtkTreeSelection *selection;
+	LV_MARK;
+	g_assert (GTK_IS_TREE_SELECTION (selection));
 
-    g_return_if_fail (LOG_IS_LIST (list));
-    g_return_if_fail (LOGVIEW_IS_WINDOW (logview));
+	if (!gtk_tree_selection_get_selected (selection, &model, &iter)) {
+		logview_select_log (logview, NULL);
+		return;
+	}
 
-    selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
-    g_signal_connect (G_OBJECT (selection), "changed",
-                      G_CALLBACK (loglist_selection_changed), logview);
+	gtk_tree_model_get (model, &iter, 
+			    LOG_POINTER, &log, 
+			    LOG_WEIGHT_SET, &bold, -1);
+	/* there is a differnt selection before,
+	   check if there is a pending loglist_unbold */
+	if (logview_get_active_log (logview) != log) {
+		if (self->prv->unbold_event > 0) {
+			gboolean ret = FALSE;
+			ret = g_source_remove (self->prv->unbold_event);
+			g_assert (ret);
+			self->prv->unbold_event = 0;
+		}
+	}
+	logview_select_log (logview, log);
+	if (bold) {
+		self->prv->unbold_event = 
+			g_timeout_add (BOLD_LOG_TIME,
+				       (GSourceFunc) loglist_unbold,
+				       g_object_ref (self));
+	}
 }
 
 static void 
 loglist_init (LogList *list)
 {
-    GtkTreeStore *model;
-    GtkTreeViewColumn *column;
-    GtkTreeSelection *selection;
-    GtkCellRenderer *cell;
+	GtkTreeStore *model;
+	GtkTreeViewColumn *column;
+	GtkTreeSelection *selection;
+	GtkCellRenderer *cell;
 
-    list->priv = g_new0 (LogListPriv, 1);
+	list->prv = g_new0 (LogListPrv, 1);
 
-    model = gtk_tree_store_new (4, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_BOOLEAN);
-    gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (model));
-    list->priv->model = model;
-    gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (list), FALSE);
-    g_object_unref (G_OBJECT (model));
+	model = gtk_tree_store_new (4, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_BOOLEAN);
+	gtk_tree_view_set_model (GTK_TREE_VIEW (list), GTK_TREE_MODEL (model));
+	list->prv->model = model;
+	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (list), FALSE);
+	g_object_unref (G_OBJECT (model));
 
-    selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
-    gtk_tree_selection_set_mode (selection, GTK_SELECTION_BROWSE);
+	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
+	gtk_tree_selection_set_mode (selection, GTK_SELECTION_BROWSE);
+	g_signal_connect (G_OBJECT (selection), "changed",
+			  G_CALLBACK (loglist_selection_changed), list);
     
-    cell = gtk_cell_renderer_text_new ();
-    column = gtk_tree_view_column_new ();
-    gtk_tree_view_column_pack_start (column, cell, TRUE);
-    gtk_tree_view_column_set_attributes (column, cell,
-					 "text", LOG_NAME,
-					 "weight-set", LOG_WEIGHT_SET,
-					 "weight", LOG_WEIGHT,
-					 NULL);
-
-    gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE(list->priv->model), 0, GTK_SORT_ASCENDING);
-    gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
-    gtk_tree_view_set_search_column (GTK_TREE_VIEW (list), -1);
+	cell = gtk_cell_renderer_text_new ();
+	column = gtk_tree_view_column_new ();
+	gtk_tree_view_column_pack_start (column, cell, TRUE);
+	gtk_tree_view_column_set_attributes (column, cell,
+					     "text", LOG_NAME,
+					     "weight-set", LOG_WEIGHT_SET,
+					     "weight", LOG_WEIGHT,
+					     NULL);
+
+	gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE(list->prv->model), 0, GTK_SORT_ASCENDING);
+	gtk_tree_view_append_column (GTK_TREE_VIEW (list), column);
+	gtk_tree_view_set_search_column (GTK_TREE_VIEW (list), -1);
 }
 
 static void
 loglist_finalize (GObject *object)
 {
 	LogList *list = LOG_LIST (object);
-	g_free (list->priv);
-	parent_class->finalize (object);
+	g_free (list->prv);
+	(*G_OBJECT_CLASS(loglist_parent_class)->finalize) (object); 
 }
 
 static void
 loglist_class_init (LogListClass *klass)
 {
 	GObjectClass *object_class = (GObjectClass *) klass;
-	parent_class = g_type_class_peek_parent (klass);
+	GParamSpec *pspec;
+
 	object_class->finalize = loglist_finalize;
+        object_class->set_property = loglist_set_property;
+
+	pspec = g_param_spec_pointer ("window",
+				      "LogviewWindow pointer",
+				      "Set LogviewWindow pointer",
+				      G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY);
+	g_object_class_install_property (object_class,
+					 PROP_WINDOW,
+					 pspec);
 }
 
-GType
-loglist_get_type (void)
+static void
+loglist_set_property (GObject      *object,
+		      guint         property_id,
+		      const GValue *value,
+		      GParamSpec   *pspec)
 {
-	static GType object_type = 0;
-	
-	if (!object_type) {
-		static const GTypeInfo object_info = {
-			sizeof (LogListClass),
-			NULL,		/* base_init */
-			NULL,		/* base_finalize */
-			(GClassInitFunc) loglist_class_init,
-			NULL,/* class_finalize */
-			NULL,		/* class_data */
-			sizeof (LogList),
-			0,              /* n_preallocs */
-			(GInstanceInitFunc) loglist_init
-		};
-
-		object_type = g_type_register_static (GTK_TYPE_TREE_VIEW, "LogList", &object_info, 0);
+	LogList *self = LOG_LIST (object);
+
+	switch (property_id) {
+	case PROP_WINDOW:
+		self->prv->window = g_value_get_pointer (value);
+		g_assert (LOGVIEW_IS_WINDOW(self->prv->window));
+		break;
+	default:
+		/* We don't have any other property... */
+		G_OBJECT_WARN_INVALID_PROPERTY_ID(object,property_id,pspec);
+		break;
 	}
-
-	return object_type;
 }
 
 GtkWidget *
-loglist_new (void)
+loglist_new (gpointer window)
 {
     GtkWidget *widget;
-    widget = g_object_new (LOG_LIST_TYPE, NULL);
+    widget = g_object_new (LOG_LIST_TYPE, "window", window, NULL);
     return widget;
 }
diff --git a/logview/loglist.h b/logview/loglist.h
index c7f766a..b3da652 100644
--- a/logview/loglist.h
+++ b/logview/loglist.h
@@ -17,6 +17,9 @@
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
 
+
+/* loglist is the left choice panel */
+
 #ifndef __LOG_LIST_H__
 #define __LOG_LIST_H__
 
@@ -27,11 +30,11 @@
 #define LOG_IS_LIST_CLASS(klass)  (GTK_CHECK_CLASS_TYPE ((obj), LOG_LIST_TYPE))
 #define LOG_LIST_GET_CLASS(obj)   (GTK_CHECK_GET_CLASS ((obj), LOG_LIST_TYPE, LogListClass))
 
-typedef struct LogListPriv LogListPriv;
+typedef struct LogListPrv LogListPrv;
 typedef struct LogList
 {	
-    GtkTreeView parent_instance;
-    LogListPriv *priv;
+	GtkTreeView parent_instance;
+	LogListPrv *prv;
 }LogList;
 
 typedef struct LogListClass
@@ -40,12 +43,10 @@ typedef struct LogListClass
 }LogListClass;
 
 GType loglist_get_type (void);
-GtkWidget *loglist_new (void);
-void loglist_connect (LogList *list, LogviewWindow *window);
+GtkWidget *loglist_new (gpointer window);
 void loglist_add_log (LogList *list, Log *log);
 void loglist_remove_log (LogList *list, Log *log);
 void loglist_select_log (LogList *list, Log *log);
 void loglist_bold_log (LogList *list, Log *log);
-void loglist_unbold_log (LogList *list, Log *log);
 
 #endif /* __LOG_LIST_H__ */
diff --git a/logview/logrtns.c b/logview/logrtns.c
index 8300142..f61cf06 100644
--- a/logview/logrtns.c
+++ b/logview/logrtns.c
@@ -1,22 +1,22 @@
-/*  ----------------------------------------------------------------------
+/*	----------------------------------------------------------------------
 
-    Copyright (C) 1998  Cesar Miquel  (miquel@df.uba.ar)
+	Copyright (C) 1998	Cesar Miquel  (miquel@df.uba.ar)
 
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 2 of the License, or
-    (at your option) any later version.
+	This program is free software; you can redistribute it and/or modify
+	it under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2 of the License, or
+	(at your option) any later version.
 
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
+	This program is distributed in the hope that it will be useful,
+	but WITHOUT ANY WARRANTY; without even the implied warranty of
+	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+	GNU General Public License for more details.
 
-    You should have received a copy of the GNU General Public License
-    along with this program; if not, write to the Free Software
-    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+	You should have received a copy of the GNU General Public License
+	along with this program; if not, write to the Free Software
+	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
-    ---------------------------------------------------------------------- */
+	---------------------------------------------------------------------- */
 
 #ifdef __CYGWIN__
 #define timezonevar
